# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   test65
# FileName:      test_dependency_demo.py
# Author:       lao_zhao
# Datetime:     2025/3/11 9:36
# Description:
# typescript -- javascript
# ---------------------------------------------------------------------------
import pytest
import requests


# 数据依赖时，尽量设置一个全局变量为可变类型
depends_data = {}

# 标记当前用例会被后续的用例依赖
@pytest.mark.dependency(scope="module")
def test_func1():
    req = requests.sessions.Session()
    res = req.post(url="http://36.139.193.99:8088/auth", json={"username": "admin",
                                                         "password": "FMdrV2BOQbG4L+z83m+0X1+sS9ZjdHnmvZoUQI7cmv1YW///jK1vwsa4rJang9t+P+j9sPNM1gH/MAJ4frtA0mSvqTygUPj1cv3Lb5DTvwbvzC79osvC7EGH3pqYrWXiicx5PzghVYpstgTkWvniJ9CAiVVwtrj/q1AlWzqUB2U="})
    try:
        assert "loginStatus" in res.text
    except AssertionError:
        raise AssertionError("断言失败")
    else:
        token = res.json().get("token")
        depends_data["token"] = token


# 指定用例2所依赖的用例
@pytest.mark.dependency(depends=["test_func1"], scope="module")   # 标记当前用例会被后续的用例依赖
def test_func2():
    print("测试用例函数2")
    print("取出token", depends_data["token"])
    assert 1 == 1


# 用例3执行时，依赖用例1和用例2一定要成功
@pytest.mark.dependency(depends=["test_func1", "test_func2"], scope="module")
def test_func3():
    print("测试用例函数3")


class TestDemo:

    @pytest.mark.dependency(depends=["test_func3"], scope="module")
    def test_method1(self):
        print("用例方法")


@pytest.mark.dependency(depends=["TestDemo::test_method1"], scope="module")
def test_func4():
    print("测试用例函数4")


if __name__ == '__main__':
    pytest.main()